--[[

	Based on an idea from sarf (Free Bag Slots)

	Originally coded by Hamunaptra.
	Currently updated by Earl_Parvisjam

	This mod displays free and total slots in all bags.
	Added bag slots info for bank bags.
   ]]
   
Bagmeter_Version = "BC_0001";
Bagmeter_Total = 1;    		-- show total by default
Bagmeter_Subtotal = 1; 		-- show subtotals by default
Bagmeter_Color = 0;    		-- don't colorize by default
Bagmeter_Used = 0;     		-- show free by default
Bagmeter_Subcount = 1; 		-- show subcounts by default
Bagmeter_CountCraft = 1;	-- show totals including craft bags by default
Bagmeter_CountAmmo = 1;		-- show totals including ammo/soul bags by default

function Bagmeter_OnLoad(self)
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	self:RegisterEvent("BANKFRAME_OPENED");
	SLASH_BAGMETER1 = "/bagm";
    SlashCmdList["BAGMETER"] = Bagmeter_CommandHandler;
	Bagmeter_Print("Bagmeter "..Bagmeter_Version.." loaded.", "yellow");
end

function Bagmeter_CommandHandler(msg)
	local Cmd, Arg = Bagmeter_ParseMsg(msg);
 	if (Cmd == "total") then
 		Bagmeter_Total = Arg;
		Bagmeter_OnEvent(1);
		Bagmeter_DisplayStatus();
	elseif (Cmd == "countammo") then
 		Bagmeter_CountAmmo = Arg;
		Bagmeter_OnEvent(1);
		Bagmeter_DisplayStatus();
	elseif (Cmd == "countcraft") then
 		Bagmeter_CountCraft = Arg;
		Bagmeter_OnEvent(1);
		Bagmeter_DisplayStatus();
 	elseif (Cmd == "subtotal") then
 		Bagmeter_Subtotal = Arg;
 		Bagmeter_OnEvent(1);
 		Bagmeter_DisplayStatus();
	elseif (Cmd == "subcount") then
	 	Bagmeter_Subcount = Arg;
 		Bagmeter_OnEvent(1);
 		Bagmeter_DisplayStatus();
 	elseif (Cmd == "color") then
 		Bagmeter_Color = Arg;
 		Bagmeter_OnEvent(1);
 		Bagmeter_DisplayStatus();
 	elseif (Cmd == "show") then
 		Bagmeter_Used = Arg;
 		Bagmeter_OnEvent(1);
 		Bagmeter_DisplayStatus();
 	elseif (Cmd == "status") then
 		Bagmeter_DisplayStatus();
 	else
 		Bagmeter_DisplayHelp();
 	end;
end;

function Bagmeter_OnEvent(event)
	local i, j, ofree, ototal, cfree, ctype, ctotal, obj, txt1, txt2, col, ratio;

	ofree = 0;
	ototal = 0;

	for i = 0, 4 do
		cfree, ctype = GetContainerNumFreeSlots(i);
		ctotal = GetContainerNumSlots(i);
		
		if (ctype == nil) then
			ctype = 2048;
		end
		
		if (Bagmeter_CountAmmo == 0 and ctype > 0 and ctype <= 4) then
			txt1 = "*";
		elseif (Bagmeter_CountCraft == 0 and ctype > 4) then
			txt1 = "*";
		else
			txt1 = "";
			ofree = ofree + cfree;
			ototal = ototal + ctotal;
		end
		obj = getglobal("BM_Bag"..i.."Txt");

		if (Bagmeter_Used == 1) then
			txt2 = ctotal - cfree;
		else
			txt2 = cfree;
		end
		if (Bagmeter_Subcount == 1) then
			if (Bagmeter_Subtotal == 1) then
				txt1 = txt1..txt2.."/"..ctotal..txt1;
			else
				txt1 = txt1..txt2..txt1;
			end
		else
			if (Bagmeter_Subtotal == 1) then
				txt1 = txt1..ctotal..txt1;
			else
				txt1 = txt1.."";
			end
		end
		
		col = "white";
		
		if (Bagmeter_Color == 1) then
			ratio = cfree / ctotal;
			col = "green";
			if (ratio < 0.66) then col = "yellow"; end
			if (ratio < 0.33) then col = "red"; end
		end

		obj:SetText(txt1);
		obj:SetTextColor(Bagmeter_GetColor(col));
        obj:Show();
        
		obj = getglobal("BM_Bag"..i.."Frame");
        if ( ctotal > 0) then
            obj:Show();
		else
		    obj:Hide();
		end
	end

	for i = 5, (4 + GetNumBankSlots()) do
		cfree, ctype = GetContainerNumFreeSlots(i);
		ctotal = GetContainerNumSlots(i);
		ofree = ofree + cfree;
		ototal = ototal + ctotal;
		
		obj = getglobal("BM_Bag"..i.."Txt");
		if (Bagmeter_Used == 1) then
			txt2 = ctotal - cfree;
		else
			txt2 = cfree;
		end

		if (Bagmeter_Subcount == 1) then
			if (Bagmeter_Subtotal == 1) then
				txt1 = txt2.."/"..ctotal;
			else
				txt1 = txt2;
			end
		else
			if (Bagmeter_Subtotal == 1) then
				txt1 = ctotal;
			else
				txt1 = "";
			end
		end
		col = "white";
		
		if (Bagmeter_Color == 1) then
			ratio = cfree / ctotal;
			col = "green";
			if (ratio < 0.66) then col = "yellow"; end
			if (ratio < 0.33) then col = "red"; end
		end

		obj:SetText(txt1);
		obj:SetTextColor(Bagmeter_GetColor(col));
        obj:Show();
        
		obj = getglobal("BM_Bag"..i.."Frame");
        if ( ctotal > 0) then
            obj:Show();
		else
		    obj:Hide();
		end
	end

	if (Bagmeter_Used == 1) then
		txt1 = ototal - ofree;
	else
		txt1 = ofree;
	end
	
	if (Bagmeter_Total == 1) then
		BM_BagXTxt:SetText(txt1.."/"..ototal);
	else
		BM_BagXTxt:SetText("");
	end
	
	col = "white";
		
	if (Bagmeter_Color == 1) then
		ratio = ofree / ototal;
		col = "green";
		if (ratio < 0.66) then col = "yellow"; end
		if (ratio < 0.33) then col = "red"; end
	end
	BM_BagXTxt:SetTextColor(Bagmeter_GetColor(col));
	GM_GUIFrame_Update();
end
 
function Bagmeter_ParseMsg(msg)
 	if msg then
 		local txt
 		local a, b, c = strfind(msg, "(%S+)");
 		if a then
 			txt = strsub(msg, b + 2);
 			if (txt == "on" or txt == "used" or txt == "yes" or txt == "1") then
 				return c, 1;
 			else
 				return c, 0;
 			end
 		else
 			return "";
 		end
 	end
end

function Bagmeter_ParseSet(setting)
	if (setting == 1) then return "yes"; end
	return "no";
end

function Bagmeter_Print(msg, color)
	local r, g, b;
	if (msg == nil) then return; end
	r, g, b = Bagmeter_GetColor(color);
	if( DEFAULT_CHAT_FRAME ) then DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b); end
end
	
function Bagmeter_GetColor(color)
	if (color == "green") then return 0, 1, 0; end
	if (color == "red") then return 1, 0, 0; end
	if (color == "yellow") then	return 1, 1, 0;	end
	return 1, 1, 1;
end

function Bagmeter_DisplayHelp()
	Bagmeter_Print("---------------------------------------", "yellow");
	Bagmeter_Print("Bagmeter usage:", "yellow");
	Bagmeter_Print("/bagm total on/off -> Show or hide free/used space overall", "white");
	Bagmeter_Print("/bagm subcount on/off -> Show or hide per bag counts", "white");
	Bagmeter_Print("/bagm subtotal on/off -> Show or hide free/used space per bag", "white");
	Bagmeter_Print("/bagm color on/off -> Use colors for the bag utilization", "white");
	Bagmeter_Print("/bagm show free/used -> Show either the free or the used spaces per bag and overall", "white");
	Bagmeter_Print("/bagm status -> Show the current status of the settings", "white");
	Bagmeter_Print("/bagm countammo on/off-> Count or ignore ammo/soul bags", "white");
	Bagmeter_Print("/bagm countcraft on/off-> Count or ignore craft bags", "white");
	Bagmeter_Print("---------------------------------------", "yellow");
end

function Bagmeter_DisplayStatus()
	Bagmeter_Print("---------------------------------------", "yellow");
	Bagmeter_Print("Current bagmeter settings:", "yellow");
	Bagmeter_Print("Count ammo/soul bags: "..Bagmeter_ParseSet(Bagmeter_CountAmmo), "white");
	Bagmeter_Print("Count craft bags: "..Bagmeter_ParseSet(Bagmeter_CountCraft), "white");
	Bagmeter_Print("Show total: "..Bagmeter_ParseSet(Bagmeter_Total), "white");
	Bagmeter_Print("Show subtotals: "..Bagmeter_ParseSet(Bagmeter_Subtotal), "white");
	Bagmeter_Print("Show subcounts: "..Bagmeter_ParseSet(Bagmeter_Subcount), "white");
	Bagmeter_Print("Use colors: "..Bagmeter_ParseSet(Bagmeter_Color), "white");
	Bagmeter_Print("Show used count: "..Bagmeter_ParseSet(Bagmeter_Used), "white");

	Bagmeter_Print("---------------------------------------", "yellow");
end

---------------------------------------------------
-- BM_GUIFrame_OnLoad
---------------------------------------------------

function BM_GUIFrame_OnLoad(panel)
	panel.name = "Bagmeter";
	InterfaceOptions_AddCategory(panel);
end

---------------------------------------------------
-- GM_GUIFrame_Update
---------------------------------------------------

function GM_GUIFrame_Update()
	if (Bagmeter_Total == 1) then
		BM_GUIFrame_Total:SetChecked(true);
	else 
		BM_GUIFrame_Total:SetChecked(false);
	end
	if (Bagmeter_Subcount == 1) then
		BM_GUIFrame_PerBagCount:SetChecked(true);
	else 
		BM_GUIFrame_PerBagCount:SetChecked(false);
	end
	if (Bagmeter_Subtotal == 1) then
		BM_GUIFrame_SubTotal:SetChecked(true);
	else
		BM_GUIFrame_SubTotal:SetChecked(false);
	end
	if (Bagmeter_Color == 1) then
		BM_GUIFrame_UseColors:SetChecked(true);
	else
		BM_GUIFrame_UseColors:SetChecked(false);
	end
	if (Bagmeter_Used == 0) then
		BM_GUIFrame_FreeUsed:SetChecked(true);
	else
		BM_GUIFrame_FreeUsed:SetChecked(false);
	end	
	if (Bagmeter_CountAmmo == 1) then
		BM_GUIFrame_CountAmmo:SetChecked(true);
	else
		BM_GUIFrame_CountAmmo:SetChecked(false);
	end	
	if (Bagmeter_CountCraft == 1) then
		BM_GUIFrame_CountCraft:SetChecked(true);
	else
		BM_GUIFrame_CountCraft:SetChecked(false);
	end	
end
